<template>
  <div id="index">
    <el-row>
      <el-col :span="24" class="main animate__animated animate__backInRight">
        <el-col :span="24" class="idemand">
          <el-image class="image" :src="demand" fit="fill" />
          <div class="select">
            <el-row class="select_1">
              <el-col class="over" :span="6" v-if="oneList.length > 0">
                <div class="list">
                  <div class="left">技术领域：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in oneList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'one')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="twoList.length > 0">
                <div class="list">
                  <div class="left">合作类型：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in twoList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'two')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="thrList.length > 0">
                <div class="list">
                  <div class="left">项目地区：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in thrList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'thr')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="fourList.length > 0">
                <div class="list">
                  <div class="left">成熟度：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in fourList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'four')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
            </el-row>
          </div>
        </el-col>
        <div class="w_1200">
          <el-col :span="24" class="one">
            <el-row class="one_1">
              <el-col :span="3" class="left">技术领域</el-col>
              <el-col :span="20" class="right" v-if="oneShow">
                <a-button
                  class="title"
                  v-for="(item, index) in fieldList"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'one')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
              <el-col :span="20" class="right" v-else>
                <a-button
                  class="title"
                  v-for="(item, index) in fieldList.slice(0, 8)"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'one')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
              <el-col :span="1" class="button">
                <span v-if="!oneShow" @click="oneShow = true">
                  更多
                  <el-icon><ArrowDown /></el-icon>
                </span>
                <span v-else @click="oneShow = false">
                  收起
                  <el-icon><ArrowUp /></el-icon>
                </span>
              </el-col>
            </el-row>
            <el-row class="one_1">
              <el-col :span="3" class="left">合作类型</el-col>
              <el-col :span="21" class="right">
                <a-button
                  class="title"
                  v-for="(item, index) in projectList"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'two')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
            </el-row>
            <el-row class="one_1">
              <el-col :span="3" class="left">项目地区</el-col>
              <el-col :span="20" class="right" v-if="twoShow">
                <a-button
                  class="title"
                  v-for="(item, index) in cityList"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'thr')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
              <el-col :span="20" class="right" v-else>
                <a-button
                  class="title"
                  v-for="(item, index) in cityList.slice(0, 10)"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'thr')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
              <el-col :span="1" class="button">
                <span v-if="!twoShow" @click="twoShow = true">
                  更多
                  <el-icon><ArrowDown /></el-icon>
                </span>
                <span v-else @click="twoShow = false">
                  收起
                  <el-icon><ArrowUp /></el-icon>
                </span>
              </el-col>
            </el-row>
            <el-row class="one_1">
              <el-col :span="3" class="left">成熟度</el-col>
              <el-col :span="21" class="right">
                <a-button
                  class="title"
                  v-for="(item, index) in maturityList"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(item, 'four')"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
            </el-row>
          </el-col>
          <el-col :span="24" class="two">
            <a-list :loading="loading" :grid="{ gutter: 14, column: 4 }" :data-source="list">
              <template #renderItem="{ item }">
                <el-col :span="24" class="list">
                  <el-col :span="24" class="name textOver">
                    <el-tooltip effect="dark" :content="item.name" placement="top">
                      {{ item.name || '暂无名称' }}
                    </el-tooltip>
                  </el-col>
                  <el-col :span="24" class="two_1">
                    <span>合作类型：</span>{{ getDict(item.maturity, 'maturity') }}
                  </el-col>
                  <el-col :span="24" class="two_1">
                    <span>技术成熟度：</span>{{ getDict(item.cooperate, 'cooperate') }}
                  </el-col>
                  <el-col :span="24" class="two_1"> <span>发布日期：</span>{{ item.time }} </el-col>
                  <el-col :span="24" class="bottom">
                    <div class="status">{{ getDict(item.type, 'type') }}</div>
                    <div class="button" @click="toView(item)">查看详情</div>
                  </el-col>
                </el-col>
              </template>
            </a-list>
          </el-col>
          <el-col :span="24" class="thr">
            <el-pagination
              background
              layout="total, prev, pager, next"
              :page-sizes="[10, 20, 50, 100, 200]"
              :total="total"
              :page-size="limit"
              v-model:current-page="currentPage"
              @current-change="changePage"
              @size-change="sizeChange"
            >
            </el-pagination>
          </el-col>
        </div>
      </el-col>
    </el-row>
  </div>
</template>

<script setup>
import { getCity } from '@/utils/city'
const $checkRes = inject('$checkRes')
import { get } from 'lodash-es'
// 接口
import { ProjectStore } from '@/store/api/platform/project'
import { DictDataStore } from '@/store/api/system/dictData'
const store = ProjectStore()
const dictDataStore = DictDataStore()
// 图片引入
import demand from '@/assets/innovation.png'
// 路由
const router = useRouter()
// 加载中
const loading = ref(false)
const searchForm = ref({})
// 列表
const list = ref([])
let skip = 0
let limit = inject('limit')
const total = ref(0)
// 字典表
// 字典表
const projectList = ref([])
const maturityList = ref([])
const industryList = ref([])
// 字典表
const fieldList = ref([])
const cityList = ref([])
// 查询
const oneList = ref([])
const twoList = ref([])
const thrList = ref([])
const fourList = ref([])
// 是否展开
const oneShow = ref(false)
const twoShow = ref(false)
// 查看
const toView = (item) => {
  router.push({ path: '/project/detail', query: { id: item.id || item._id } })
}
// 请求
onMounted(async () => {
  loading.value = true
  await searchOther()
  await search({ skip, limit })
  loading.value = false
})
const searchOther = async () => {
  let result
  // 合作类型
  result = await dictDataStore.query({ code: 'projectType', is_use: '0' })
  if ($checkRes(result)) projectList.value = result.data
  // 成熟度
  result = await dictDataStore.query({ code: 'projectMaturity', is_use: '0' })
  if ($checkRes(result)) maturityList.value = result.data
  // 行业分类
  result = await dictDataStore.query({ code: 'industry', is_use: '0' })
  if ($checkRes(result)) industryList.value = result.data
  // 技术领域
  result = await dictDataStore.query({ code: 'field', is_use: '0' })
  if ($checkRes(result)) fieldList.value = result.data
  // 城市
  getCity().then((response) => (cityList.value = response.address))
}
const search = async (query = { skip: 0, limit }) => {
  const info = {
    skip: query.skip,
    limit: query.limit,
    ...searchForm.value,
    is_use: '0',
    status: '1'
  }
  const res = await store.query(info)
  if (res.errcode == '0') {
    list.value = res.data
    total.value = res.total
  }
}
// 字典数据转换
const getDict = (data, model) => {
  let res
  if (model == 'cooperate') res = projectList.value.find((f) => f.value == data)
  else if (model == 'maturity') res = maturityList.value.find((f) => f.value == data)
  else if (model == 'type') res = industryList.value.find((f) => f.value == data)
  return get(res, 'label')
}
// 选择查询
const toSelect = (item, num) => {
  if (item.is_active) return
  if (num == 'one') {
    for (const val of fieldList.value) {
      if (val.value == item.value) val.is_active = true
    }
    const one = oneList.value.find((f) => f.value == item.value)
    if (!one) oneList.value.push(item)
    else oneList.value = oneList.value.filter((f) => f.value == item.value)
  }
  if (num == 'two') {
    for (const val of projectList.value) {
      if (val.value == item.value) val.is_active = true
    }
    const two = twoList.value.find((f) => f.value == item.value)
    if (!two) twoList.value.push(item)
    else twoList.value = twoList.value.filter((f) => f.value == item.value)
  }
  if (num == 'thr') {
    for (const val of cityList.value) {
      if (val.value == item.value) val.is_active = true
    }
    const thr = thrList.value.find((f) => f.value == item.value)
    if (!thr) thrList.value.push(item)
    else thrList.value = thrList.value.filter((f) => f.value == item.value)
  }
  if (num == 'four') {
    for (const val of maturityList.value) {
      if (val.value == item.value) val.is_active = true
    }
    const four = fourList.value.find((f) => f.value == item.value)
    if (!four) fourList.value.push(item)
    else fourList.value = fourList.value.filter((f) => f.value == item.value)
  }
}
// 删除标签
const toDel = (item, type) => {
  if (type == 'one') {
    const one = oneList.value.filter((f) => f.value != item.value)
    oneList.value = one
    for (const i of fieldList.value) {
      if (i.value == item.value) i.is_active = !i.is_active
    }
  }
  if (type == 'two') {
    const two = twoList.value.filter((f) => f.value != item.value)
    twoList.value = two
    for (const i of projectList.value) {
      if (i.value == item.value) i.is_active = !i.is_active
    }
  }
  if (type == 'thr') {
    const thr = thrList.value.filter((f) => f.value != item.value)
    thrList.value = thr
    for (const i of cityList.value) {
      if (i.value == item.value) i.is_active = !i.is_active
    }
  }
  if (type == 'four') {
    const four = fourList.value.filter((f) => f.value != item.value)
    fourList.value = four
    for (const i of maturityList.value) {
      if (i.value == item.value) i.is_active = !i.is_active
    }
  }
}
const currentPage = ref(1)
// 分页
const changePage = (page = currentPage.value) => {
  search({ skip: (page - 1) * limit, limit: limit })
}
const sizeChange = (limits) => {
  limit = limits
  currentPage.value = 1
  search({ skip: 0, limit: limit })
}
</script>
<style lang="scss" scoped>
.main {
  background: rgb(248, 248, 248);

  .idemand {
    position: relative;
    .image {
      width: 100%;
      height: 200px;
    }
    .select {
      width: 1200px;
      position: absolute;
      left: 18.5%;
      bottom: 10%;
      .select_1 {
        display: flex;
        align-items: flex-end;
        .over {
          max-height: 106px;
          overflow-y: auto;
          .list {
            border-radius: 5px;
            margin-right: 10px;
            background-color: #fff;
            padding: 5px;
            font-size: 14px;
            .left {
              padding: 10px;
            }
            .right {
              display: flex;
              flex-wrap: wrap;
              .label {
                display: flex;
                align-items: center;
                margin: 3px;
                padding: 5px;
                background: #f5f5f5;
                border: 1px solid #f0f0f0;
                border-radius: 2px;
              }
            }
          }
        }
        .over::-webkit-scrollbar {
          display: none;
        }
      }
    }
  }

  .one {
    background: #ffffff;
    border-radius: 10px;
    padding: 15px;
    margin: 10px 0 0 0;

    .one_1 {
      display: flex;
      align-items: center;
      padding: 10px 0;
      border-bottom: #9d9898 1px dashed;

      .left {
        background: #2280ff;
        border-radius: 15px;
        line-height: 26px;
        color: #fff;
        text-align: center;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
        font-family: PingFangSC-Medium;
      }

      .right {
        .show {
          color: #2374ff !important;
        }
        .title {
          color: #666;
          font-size: 14px;
          line-height: 15px;
          margin: 0 10px;
          display: inline-block;
          overflow: hidden;
          text-decoration: none;
        }

        .title:hover {
          color: #2374ff;
        }
      }
      .button {
        color: #2374ff;
        font-size: 12px;
      }
    }
  }

  .two {
    margin: 15px;
    .list {
      background: #fff;
      box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.03);
      border-radius: 2px;
      width: 285px;
      height: 195px;
      margin-bottom: 15px;
      cursor: pointer;
      transition: all 0.3s;
      padding: 20px;

      .name {
        font-size: 16px;
        color: #121834;
        height: 16px;
        line-height: 13px;
        font-weight: 500;
        margin: 10px 0;
      }

      .name:hover {
        color: #2374ff;
      }

      .two_1 {
        font-size: 12px;
        text-align: justify;
        line-height: 12px;
        font-weight: 400;
        letter-spacing: 0;
        color: #8f97a3;
        margin-top: 15px;

        span:last-child {
          color: #525a68;
        }
      }

      .bottom {
        display: flex;
        align-items: center;
        justify-content: space-between;
        margin-top: 20px;

        .status {
          padding: 5px 12px;
          font-size: 12px;
          color: #2374ff;
          line-height: 12px;
          font-weight: 400;
          background: rgba(35, 116, 255, 0.05);
          border-radius: 16px;
        }

        .button {
          font-size: 12px;
          color: #fff;
          text-align: center;
          line-height: 12px;
          font-weight: 500;
          padding: 5px 12px;
          background: #2374ff;
          box-shadow: 0 3px 6px 0 rgba(35, 116, 255, 0.1);
          border-radius: 2px;
        }
      }
    }

    .list:hover {
      background: #f0f7ff;
      box-shadow: 0 0 16px rgba(205, 205, 205, 0.6);
    }
  }

  .thr {
    display: flex;
    flex-direction: row-reverse;
    padding: 20px;
  }
}
</style>
